import greenfoot.*;

public class Background extends World
{
    int squareCount, powerCount, score, spawnX, spawnY, lifeTime;
    int numberOfLives = 3;
    boolean pointBoostActive, allRedActive, invincibilityActive, timeSlowActive;
    TextDisplayer allCount = new TextDisplayer();
    SimpleTimer lifeTimer = new SimpleTimer();
    SimpleTimer powerUpTimer = new SimpleTimer();
    MousePlayer player = new MousePlayer();

    public Background()
    {    
        super(900, 600, 1, false); 
        addObject(player, getWidth() / 2, getHeight() / 2);
        addObject(allCount, 0, 0);
    }

    public void started() 
    {
        lifeTimer.mark();
    }

    public void stopped() 
    {
        lifeTime += lifeTimer.millisElapsed();
    }

    public void act() 
    {
        if(numberOfLives != 0) {
            spawnSquares();
            spawnPowers();
            applyPowers();
            allCount.setText(configureClock() + getLives() + getActivePowerUp() + "\nScore: " + score);
        } else if (getObjects(ScoreBoard.class).isEmpty()) {
            addObject(new ScoreBoard(800, 600), getWidth() / 2, getHeight() / 2);
            removeObject(player);
        }
    }

    public void spawnSquares() 
    {
        if (squareCount <= 69) {
            int sideChoose = Greenfoot.getRandomNumber(4);
            switch(sideChoose) {
                case 0: spawnX = getWidth() + 25;
                spawnY = Greenfoot.getRandomNumber(getHeight());
                break;
                case 1: spawnX = Greenfoot.getRandomNumber(getWidth());
                spawnY = getHeight() + 25;
                break;
                case 2: spawnX = -25;
                spawnY = Greenfoot.getRandomNumber(getHeight());
                break;
                case 3: spawnX = Greenfoot.getRandomNumber(getWidth());
                spawnY = -25;
                break;
            }
            addObject(new Square(sideChoose), spawnX, spawnY);  
            squareCount++;
        } 
    }

    public void spawnPowers() {
        if (powerCount < 1) {
            int sideChoose = Greenfoot.getRandomNumber(4);
            switch(sideChoose) {
                case 0: spawnX = getWidth() + 25;
                spawnY = Greenfoot.getRandomNumber(getHeight());
                break;
                case 1: spawnX = Greenfoot.getRandomNumber(getWidth());
                spawnY = getHeight() + 25;
                break;
                case 2: spawnX = -25;
                spawnY = Greenfoot.getRandomNumber(getHeight());
                break;
                case 3: spawnX = Greenfoot.getRandomNumber(getWidth());
                spawnY = -25;
                break;
            }
            addObject(new PowerUp(sideChoose), spawnX, spawnY);  
            powerCount++;
        } 
    }

    public void applyPowers() 
    {
        if(powerUpTimer.millisElapsed() >= 5000) 
        {
            pointBoostActive = false;
            allRedActive = false;
            invincibilityActive = false;
            timeSlowActive = false;
        }
    } 

    public String getActivePowerUp() 
    {
        if (pointBoostActive == true) 
        {
            return "\nPower Up : Point Boost";
        } 
        if (allRedActive == true) 
        {
            return "\nPowerUp : All Red";
        } 
        if (invincibilityActive == true) 
        {
            return "\nPowerUp : Invincibility";
        } 
        if (timeSlowActive == true) 
        {
            return "\nPowerUp : Slow Time";
        }
        return "\nPowerUp : None";
    }

    public String configureClock() 
    {
        int seconds = (lifeTime + lifeTimer.millisElapsed()) / 1000;
        int minutes = (lifeTime + lifeTimer.millisElapsed()) / 60000;
        seconds = seconds - (minutes * 60);
        if (seconds < 10) 
        {
            return "Time elapsed: " + minutes + ":0" + seconds;
        } else {
            return "Time elapsed: " + minutes + ":" + seconds;
        }
    }

    public String getLives() 
    {
        return "\nNumber of lives: " + numberOfLives;
    }

}
