import greenfoot.*; 
import java.awt.Color;
import java.awt.Paint;

public class MousePlayer extends Actor
{
    int radius;

    public void act() 
    {
        MouseInfo cursor = Greenfoot.getMouseInfo();
        if (cursor != null) 
        {
            this.setLocation(cursor.getX(), cursor.getY());
            checkHit();
            drawSelf();
        }    
    }

    public void drawSelf() 
    {
        if (((Background) getWorld()).invincibilityActive == true) 
        {
            radius = 50;
        } else {
            radius = 10;
        }
        GreenfootImage circle = new GreenfootImage(radius, radius);
        circle.setColor(Color.BLUE);  
        circle.fillOval(0, 0, radius, radius);  
        this.setImage(circle);
    }

    public void checkHit() 
    {
        Background background = (Background) getWorld();
        if (isTouching(Square.class)) 
        {
            Square collisionSquare = (Square) getOneIntersectingObject(Square.class);
            if (collisionSquare.paintID == 0 && background.invincibilityActive == false && background.allRedActive == false)
            {
                background.numberOfLives--;
            } else {
                background.score +=  (int) collisionSquare.pointWorth;
            }
            background.removeObject(collisionSquare);
            background.squareCount--;
        }
        if(isTouching(PowerUp.class)) 
        {
            PowerUp collisionPowerUp = (PowerUp) getOneIntersectingObject(PowerUp.class);
            switch(collisionPowerUp.powerID) {
                case 0: background.pointBoostActive = true;
                break;
                case 1: background.allRedActive = true;
                break;
                case 2: background.invincibilityActive = true;
                break;
                case 3: background.timeSlowActive = true;
                break;
            }   
            background.powerCount--;
            background.powerUpTimer.mark();
            background.removeObject(collisionPowerUp);
        }
    }
}
