import greenfoot.*; 
import java.awt.Paint;
import java.awt.Color; 

public class Square extends SmoothMover {
    Color paintColor;
    int size, paintID, currentPaintID, sideChosen, deltaX, deltaY;
    float pointWorth;
    double speedModifier = 0.25;
    int pointModifier = 10;
    GreenfootImage square;

    public Square(int sideChoose) 
    {
        paintID = Greenfoot.getRandomNumber(2);
        if (paintID == 0) 
        {
            paintColor = Color.BLACK;
        } else {
            paintColor = Color.RED;
        }
        switch(sideChoose) 
        {
            case 0: deltaX = - (Greenfoot.getRandomNumber(4) + 1);
            break;
            case 1: deltaY = - (Greenfoot.getRandomNumber(4) + 1);
            break;
            case 2: deltaX = Greenfoot.getRandomNumber(4) + 1;
            break;
            case 3: deltaY = Greenfoot.getRandomNumber(4) + 1;
            break;
        }
        size = Greenfoot.getRandomNumber(15) + 15;
        sideChosen = sideChoose;
        square = new GreenfootImage(size, size);
    }

    public void act() 
    { 
        drawSelf();
        moveSelf();
        decidePointWorth();
        checkBoundaries();
    }    

    public void drawSelf() 
    {
        if (((Background) getWorld()).allRedActive == true) 
        {
            square.setColor(Color.RED);
        } else {
            square.setColor(paintColor);
        }
        square.fill();
        square.drawRect(size, size, getX(), getY());
        this.setImage(square);
    }

    public void checkBoundaries() 
    {
        switch(sideChosen) 
        {
            case 0:
            if (this.getX() <= -25)  
            {
                ((Background) getWorld()).squareCount--;
                getWorld().removeObject(this);
            }
            break;
            case 1:
            if (this.getY() <= -25)  
            {
                ((Background) getWorld()).squareCount--;
                getWorld().removeObject(this);
            }
            break;
            case 2:
            if (this.getX() >= getWorld().getWidth() + 25)  
            {
                ((Background) getWorld()).squareCount--;
                getWorld().removeObject(this);
            }
            break;
            case 3:
            if (this.getY() >= getWorld().getHeight() + 25)  
            {
                ((Background) getWorld()).squareCount--;
                getWorld().removeObject(this);
            }
            break;
        }
    }

    public void moveSelf() 
    {
        if (((Background) getWorld()).timeSlowActive == true) 
        {
            this.setLocation(getExactX() + (deltaX * speedModifier), getExactY() + (deltaY * speedModifier));
        } else {
            setLocation(getExactX() + deltaX, getExactY() + deltaY);
        }
    }
    
    public void decidePointWorth() 
    {
        if (((Background) getWorld()).pointBoostActive == true) 
        {
             pointWorth = ((200 * Math.abs(deltaX + deltaY)) / size) * pointModifier;
        } else {
             pointWorth = (200 * Math.abs(deltaX + deltaY)) / size;
        }
    }
}
